/* --------------------------------------------------------------------------------------------
 * Copyright (c) Remy Suen. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const vscode_languageserver_1 = require("vscode-languageserver");
const dockerHighlight_1 = require("./dockerHighlight");
class DockerRename {
    rename(document, position, newName) {
        let edits = [];
        let highlighter = new dockerHighlight_1.DockerHighlight();
        let highlightRanges = highlighter.computeHighlightRanges(document, position);
        for (let highlightRange of highlightRanges) {
            edits.push(vscode_languageserver_1.TextEdit.replace(highlightRange.range, newName));
        }
        return edits;
    }
}
exports.DockerRename = DockerRename;
